#include "mbed.h"
#include "math.h"
#include "bma220.h"
#include "thermistor.h"

Serial pc(USBTX, USBRX);
AnalogIn ain(A0);

void display(Quanterion Q){
    pc.printf("%f+ %fi+ %fj+ %fk \t Angle is: %f\n",Q.q0, Q.q1, Q.q2, Q.q3, Q.angle);
}

int main() {
    pc.baud(115200);
    
    I2C i2c(I2C_SDA, I2C_SCL);
    i2c.frequency(400000);
    BMA220 Sensor(&i2c);
    Thermistor thermistor(&ain);
    
    if (!Sensor.begin()) {
        pc.printf("No valid BMA220 sensor found, check wiring");
    }
    // Set sensor sensitivity to 4g
    Sensor.setRegister(SENSITIVITY_REG, SENS_2g);
    
    while(1){
        Sensor.readAcceleration(64);
        pc.printf("x-axis: ");
        pc.printf("%f\n", Sensor.getAcceleration_X());
        pc.printf("y-axis: ");
        pc.printf("%f\n",Sensor.getAcceleration_Y());
        pc.printf("z-axis: ");
        pc.printf("%f\n",Sensor.getAcceleration_Z());
    
        pc.printf("rho: ");
        pc.printf("%f\n",Sensor.getPitch());
    
        pc.printf("phi: ");
        pc.printf("%f\n",Sensor.getRoll());
    
        pc.printf("theta: ");
        pc.printf("%f\n",Sensor.getTheta());
    
        pc.printf("Mag: ");
        pc.printf("%f\n",Sensor.getMag());
    
        Sensor.FallDetection();
        display(Sensor.Q_result1);
        display(Sensor.Q_result2);
        
        wait(1);
    }   
}